# Composition vs Inheritance

---

**This may very be one of the largest debates in programming history... \(aside from IDEs, dark/bright backgrounds and spaces vs tabs\).**

### Why pick Inheritance over Composition?

* Much more rigid, tighter coupling between classes
* When we need subclasses to implement all of the characteristics of another class, but add on to it.
* When we need polymorphism
* Loans itself particularly well to GUI design

### When to pick Composition over Inheritance?

* Much looser coupling between classes
* When we desire reusability
* When we want classes to be highly focused on a particular task

### Instructors Opinion

**Composition over inheritance!**

Now... that doesn't mean you should always use composition. That just means to favor composition over inheritance. If it takes a ton of work to implement composition, but the code isn't very reusable or functional... use inheritance. Otherwise, if you can use composition without any major negative side effects... use it. Composition will scale better. 

